Skip to main content

Tag inputs render tags inside an input, followed by an actual text input. By default, tags are added when text is typed in the input field and the Enter or Comma key is pressed. Throughout the interaction, DOM focus remains on the input element.

React
Vue
Properties

Features

  • Typing in the input and pressing enter will add new items
  • Clear button to reset all tags values
  • Add tags by pasting into the input
  • Delete tags on backspace
  • Edit tags after creation
  • Limit the number of tags
  • Navigate tags with keyboard
  • Custom validation to accept/reject tags

Installation

To use the tags input machine in your project, run the following command in your command line:

npm install @zag-js/tags-input @zag-js/solid # or yarn add @zag-js/tags-input @zag-js/solid

Anatomy

To set up the tags input correctly, you'll need to understand its anatomy and how we name its parts.

Each part includes a data-part attribute to help identify them in the DOM.

Usage

First, import the tags input package into your project

import * as tagsInput from "@zag-js/tags-input"

The tags input package exports two key functions:

  • machine — The state machine logic for the tags input widget.
  • connect — The function that translates the machine's state to JSX attributes and event handlers.

You'll also need to provide a unique id to the useMachine hook. This is used to ensure that every part has a unique identifier.

Next, import the required hooks and functions for your framework and use the tags input machine in your project 🔥

import * as tagsInput from "@zag-js/tags-input" import { normalizeProps, useMachine } from "@zag-js/solid" import { createMemo, createUniqueId, For } from "solid-js" export function TagsInput() { const service = useMachine(tagsInput.machine, { id: createUniqueId(), defaultValue: ["React", "Vue"], }) const api = createMemo(() => tagsInput.connect(service, normalizeProps)) return ( <div {...api().getRootProps()}> <For each={api().value}> {(value, index) => ( <span {...api().getItemProps({ index: index(), value })}> <div {...api().getItemPreviewProps({ index: index(), value })}> <span>{value} </span> <button {...api().getItemDeleteTriggerProps({ index: index(), value })} > &#x2715; </button> </div> <input {...api().getItemInputProps({ index: index(), value })} /> </span> )} </For> <input placeholder="Add tag..." {...api().getInputProps()} /> </div> ) }

When the input has an empty value or the caret is at the start position, the tags can be selected by using the arrow left and arrow right keys. When "visual" focus in on any tag:

  • Pressing Enter or double clicking on the tag will put the it in edit mode, allowing the user change its value and press Enter to commit the changes.
  • Pressing Delete or Backspace will delete the tag that has "visual" focus.

Setting the initial tags

To set the initial tag values, pass the defaultValue property in the machine's context.

const service = useMachine(tagsInput.machine, { defaultValue: ["React", "Redux", "TypeScript"], })

Controlled tags input

To control the tags input programmatically, pass the value and onValueChange properties to the machine function.

import { createSignal } from "solid-js" export function ControlledTagsInput() { const [value, setValue] = createSignal(["React", "Vue"]) const service = useMachine(tagsInput.machine, { get value() { return value() }, onValueChange(details) { setValue(details.value) }, }) return ( // ... ) }

Removing all tags

The tags input will remove all tags when the clear button is clicked. To remove all tags, use the provided clearButtonProps function from the api.

//... <div {...api.getControlProps()}> <input {...api.getInputProps()} /> <button {...api.getClearButtonProps()} /> </div> //...

To programmatically remove all tags, use the api.clearAll() method that's available in the connect.

Usage within forms

The tags input works when placed within a form and the form is submitted. We achieve this by:

  • ensuring we emit the input event as the value changes.
  • adding a name and value attribute to a hidden input so the tags can be accessed in the FormData.

To get this feature working you need to pass a name option to the context and render the hiddenInput element.

const service = useMachine(tagsInput.machine, { name: "tags", defaultValue: ["React", "Redux", "TypeScript"], })

Limiting the number of tags

To limit the number of tags within the component, you can set the max property to the limit you want. The default value is Infinity.

When the tag reaches the limit, new tags cannot be added except the allowOverflow option is passed to the context.

const service = useMachine(tagsInput.machine, { max: 10, allowOverflow: true, })

Validating Tags

Before a tag is added, the machine provides a validate function you can use to determine whether to accept or reject a tag.

Note: Duplicate tags are automatically prevented by design. You don't need to handle this in your validate function.

Common use-cases for validating tags include enforcing format, length, or content rules.

const service = useMachine(tagsInput.machine, { validate(details) { // Example: only allow lowercase alphabetic tags return /^[a-z]+$/.test(details.inputValue) }, })

Blur behavior

When the tags input is blurred, you can configure the action the machine should take by passing the blurBehavior option to the context.

  • "add" — Adds the tag to the list of tags.
  • "clear" — Clears the tags input value.
const service = useMachine(tagsInput.machine, { blurBehavior: "add", })

Paste behavior

To add a tag when a arbitrary value is pasted in the input element, pass the addOnPaste option.

When a value is pasted, the machine will:

  • check if the value is a valid tag based on the validate option
  • split the value by the delimiter option passed
const service = useMachine(tagsInput.machine, { addOnPaste: true, })

Disable tag editing

by default the tags can be edited by double clicking on the tag or focusing on them and pressing Enter. To disable this behavior, pass the allowEditTag: false

const service = useMachine(tagsInput.machine, { allowEditTag: false, })

Listening for events

During the lifetime of the tags input interaction, here's a list of events we emit:

  • onValueChange — invoked when the tag value changes.
  • onHighlightChange — invoked when a tag has visual focus.
  • onValueInvalid — invoked when the max tag count is reached or the validate function returns false.
const service = useMachine(tagsInput.machine, { onValueChange(details) { // details => { value: string[] } console.log("tags changed to:", details.value) }, onHighlightChange(details) { // details => { value: string } console.log("highlighted tag:", details.value) }, onValueInvalid(details) { console.log("Invalid!", details.reason) }, })

Styling guide

Earlier, we mentioned that each accordion part has a data-part attribute added to them to select and style them in the DOM.

Focused state

The combobox input is focused when the user clicks on the input element. In this focused state, the root, label, input.

[data-part="root"][data-focus] { /* styles for root focus state */ } [data-part="label"][data-focus] { /* styles for label focus state */ } [data-part="input"]:focus { /* styles for input focus state */ }

Invalid state

When the tags input is invalid by setting the invalid: true in the machine's context, the data-invalid attribute is set on the root, input, control, and label.

[data-part="root"][data-invalid] { /* styles for invalid state for root */ } [data-part="label"][data-invalid] { /* styles for invalid state for label */ } [data-part="input"][data-invalid] { /* styles for invalid state for input */ }

Disabled state

When the tags input is disabled by setting the disabled: true in the machine's context, the data-disabled attribute is set on the root, input, control and label.

[data-part="root"][data-disabled] { /* styles for disabled state for root */ } [data-part="label"][data-disabled] { /* styles for disabled state for label */ } [data-part="input"][data-disabled] { /* styles for disabled state for input */ } [data-part="control"][data-disabled] { /* styles for disabled state for control */ }

When a tag is disabled, the data-disabled attribute is set on the tag.

[data-part="item-preview"][data-disabled] { /* styles for disabled tag */ }

Highlighted state

When a tag is highlighted via the keyboard navigation or pointer hover, a data-highlighted attribute is set on the tag.

[data-part="item-preview"][data-highlighted] { /* styles for visual focus */ }

Readonly state

When the tags input is in its readonly state, the data-readonly attribute is set on the root, label, input and control.

[data-part="root"][data-readonly] { /* styles for readonly for root */ } [data-part="control"][data-readonly] { /* styles for readonly for control */ } [data-part="input"][data-readonly] { /* styles for readonly for input */ } [data-part="label"][data-readonly] { /* styles for readonly for label */ }

Methods and Properties

Machine Context

The tags input machine exposes the following context properties:

  • idsPartial<{ root: string; input: string; hiddenInput: string; clearBtn: string; label: string; control: string; item: (opts: ItemProps) => string; itemDeleteTrigger: (opts: ItemProps) => string; itemInput: (opts: ItemProps) => string; }>The ids of the elements in the tags input. Useful for composition.
  • translationsIntlTranslationsSpecifies the localized strings that identifies the accessibility elements and their states
  • maxLengthnumberThe max length of the input.
  • delimiterstring | RegExpThe character that serves has: - event key to trigger the addition of a new tag - character used to split tags when pasting into the input
  • autoFocusbooleanWhether the input should be auto-focused
  • disabledbooleanWhether the tags input should be disabled
  • readOnlybooleanWhether the tags input should be read-only
  • invalidbooleanWhether the tags input is invalid
  • requiredbooleanWhether the tags input is required
  • editablebooleanWhether a tag can be edited after creation, by pressing `Enter` or double clicking.
  • inputValuestringThe controlled tag input's value
  • defaultInputValuestringThe initial tag input value when rendered. Use when you don't need to control the tag input value.
  • valuestring[]The controlled tag value
  • defaultValuestring[]The initial tag value when rendered. Use when you don't need to control the tag value.
  • onValueChange(details: ValueChangeDetails) => voidCallback fired when the tag values is updated
  • onInputValueChange(details: InputValueChangeDetails) => voidCallback fired when the input value is updated
  • onHighlightChange(details: HighlightChangeDetails) => voidCallback fired when a tag is highlighted by pointer or keyboard navigation
  • onValueInvalid(details: ValidityChangeDetails) => voidCallback fired when the max tag count is reached or the `validateTag` function returns `false`
  • validate(details: ValidateArgs) => booleanReturns a boolean that determines whether a tag can be added. Useful for preventing duplicates or invalid tag values.
  • blurBehavior"clear" | "add"The behavior of the tags input when the input is blurred - `"add"`: add the input value as a new tag - `"clear"`: clear the input value
  • addOnPastebooleanWhether to add a tag when you paste values into the tag input
  • maxnumberThe max number of tags
  • allowOverflowbooleanWhether to allow tags to exceed max. In this case, we'll attach `data-invalid` to the root
  • namestringThe name attribute for the input. Useful for form submissions
  • formstringThe associate form of the underlying input element.
  • dir"ltr" | "rtl"The document's text/writing direction.
  • idstringThe unique identifier of the machine.
  • getRootNode() => ShadowRoot | Node | DocumentA root node to correctly resolve document in custom environments. E.x.: Iframes, Electron.
  • onPointerDownOutside(event: PointerDownOutsideEvent) => voidFunction called when the pointer is pressed down outside the component
  • onFocusOutside(event: FocusOutsideEvent) => voidFunction called when the focus is moved outside the component
  • onInteractOutside(event: InteractOutsideEvent) => voidFunction called when an interaction happens outside the component

Machine API

The tags input api exposes the following methods:

  • emptybooleanWhether the tags are empty
  • inputValuestringThe value of the tags entry input.
  • valuestring[]The value of the tags as an array of strings.
  • valueAsStringstringThe value of the tags as a string.
  • countnumberThe number of the tags.
  • atMaxbooleanWhether the tags have reached the max limit.
  • setValue(value: string[]) => voidFunction to set the value of the tags.
  • clearValue(id?: string) => voidFunction to clear the value of the tags.
  • addValue(value: string) => voidFunction to add a tag to the tags.
  • setValueAtIndex(index: number, value: string) => voidFunction to set the value of a tag at the given index.
  • setInputValue(value: string) => voidFunction to set the value of the tags entry input.
  • clearInputValueVoidFunctionFunction to clear the value of the tags entry input.
  • focusVoidFunctionFunction to focus the tags entry input.
  • getItemState(props: ItemProps) => ItemStateReturns the state of a tag

Data Attributes

Root
data-scope
tags-input
data-part
root
data-invalid
Present when invalid
data-readonly
Present when read-only
data-disabled
Present when disabled
data-focus
Present when focused
data-empty
Present when the content is empty
Label
data-scope
tags-input
data-part
label
data-disabled
Present when disabled
data-invalid
Present when invalid
data-readonly
Present when read-only
data-required
Present when required
Control
data-scope
tags-input
data-part
control
data-disabled
Present when disabled
data-readonly
Present when read-only
data-invalid
Present when invalid
data-focus
Present when focused
Input
data-scope
tags-input
data-part
input
data-invalid
Present when invalid
data-readonly
Present when read-only
data-empty
Present when the content is empty
Item
data-scope
tags-input
data-part
item
data-value
The value of the item
data-disabled
Present when disabled
ItemPreview
data-scope
tags-input
data-part
item-preview
data-value
The value of the item
data-disabled
Present when disabled
data-highlighted
Present when highlighted
ItemText
data-scope
tags-input
data-part
item-text
data-disabled
Present when disabled
data-highlighted
Present when highlighted
ItemDeleteTrigger
data-scope
tags-input
data-part
item-delete-trigger
data-disabled
Present when disabled
data-highlighted
Present when highlighted
ClearTrigger
data-scope
tags-input
data-part
clear-trigger
data-readonly
Present when read-only

Accessibility

Keyboard Interactions

  • ArrowLeft
    Moves focus to the previous tag item
  • ArrowRight
    Moves focus to the next tag item
  • Backspace
    Deletes the tag item that has visual focus or the last tag item
  • Enter
    When a tag item has visual focus, it puts the tag in edit mode.
    When the input has focus, it adds the value to the list of tags
  • Delete
    Deletes the tag item that has visual focus
  • Control + V
    When `addOnPaste` is set. Adds the pasted value as a tags
Edit this page on GitHub

Skip to main content

Tag inputs render tags inside an input, followed by an actual text input. By default, tags are added when text is typed in the input field and the Enter or Comma key is pressed. Throughout the interaction, DOM focus remains on the input element.

React
Vue
Properties

Features

  • Typing in the input and pressing enter will add new items
  • Clear button to reset all tags values
  • Add tags by pasting into the input
  • Delete tags on backspace
  • Edit tags after creation
  • Limit the number of tags
  • Navigate tags with keyboard
  • Custom validation to accept/reject tags

Installation

To use the tags input machine in your project, run the following command in your command line:

npm install @zag-js/tags-input @zag-js/vue # or yarn add @zag-js/tags-input @zag-js/vue

Anatomy

To set up the tags input correctly, you'll need to understand its anatomy and how we name its parts.

Each part includes a data-part attribute to help identify them in the DOM.

Usage

First, import the tags input package into your project

import * as tagsInput from "@zag-js/tags-input"

The tags input package exports two key functions:

  • machine — The state machine logic for the tags input widget.
  • connect — The function that translates the machine's state to JSX attributes and event handlers.

You'll also need to provide a unique id to the useMachine hook. This is used to ensure that every part has a unique identifier.

Next, import the required hooks and functions for your framework and use the tags input machine in your project 🔥

<script setup> import * as tagsInput from "@zag-js/tags-input" import { normalizeProps, useMachine } from "@zag-js/vue" import { computed } from "vue" const service = useMachine(tagsInput.machine, { id: "1", defaultValue: ["React", "Vue"], }) const api = computed(() => tagsInput.connect(service, normalizeProps)) </script> <template> <div ref="ref" v-bind="api.getRootProps()"> <span v-for="(value, index) in api.value" :key="index" v-bind="api.getItemProps({ index, value })" > <div v-bind="api.getItemPreviewProps({ index, value })"> <span>{{ value }} </span> <button v-bind="api.getItemDeleteTriggerProps({ index, value })"> &#x2715; </button> </div> <input v-bind="api.getItemInputProps({ index, value })" /> </span> <input placeholder="Add tag..." v-bind="api.getInputProps()" /> </div> </template>

When the input has an empty value or the caret is at the start position, the tags can be selected by using the arrow left and arrow right keys. When "visual" focus in on any tag:

  • Pressing Enter or double clicking on the tag will put the it in edit mode, allowing the user change its value and press Enter to commit the changes.
  • Pressing Delete or Backspace will delete the tag that has "visual" focus.

Setting the initial tags

To set the initial tag values, pass the defaultValue property in the machine's context.

const service = useMachine(tagsInput.machine, { defaultValue: ["React", "Redux", "TypeScript"], })

Controlled tags input

To control the tags input programmatically, pass the value and onValueChange properties to the machine function.

<script setup lang="ts"> import { ref } from "vue" const valueRef = ref(["React", "Vue"]) const service = useMachine(tagsInput.machine, { get value() { return valueRef.value }, onValueChange(details) { valueRef.value = details.value }, }) </script>

Removing all tags

The tags input will remove all tags when the clear button is clicked. To remove all tags, use the provided clearButtonProps function from the api.

//... <div {...api.getControlProps()}> <input {...api.getInputProps()} /> <button {...api.getClearButtonProps()} /> </div> //...

To programmatically remove all tags, use the api.clearAll() method that's available in the connect.

Usage within forms

The tags input works when placed within a form and the form is submitted. We achieve this by:

  • ensuring we emit the input event as the value changes.
  • adding a name and value attribute to a hidden input so the tags can be accessed in the FormData.

To get this feature working you need to pass a name option to the context and render the hiddenInput element.

const service = useMachine(tagsInput.machine, { name: "tags", defaultValue: ["React", "Redux", "TypeScript"], })

Limiting the number of tags

To limit the number of tags within the component, you can set the max property to the limit you want. The default value is Infinity.

When the tag reaches the limit, new tags cannot be added except the allowOverflow option is passed to the context.

const service = useMachine(tagsInput.machine, { max: 10, allowOverflow: true, })

Validating Tags

Before a tag is added, the machine provides a validate function you can use to determine whether to accept or reject a tag.

Note: Duplicate tags are automatically prevented by design. You don't need to handle this in your validate function.

Common use-cases for validating tags include enforcing format, length, or content rules.

const service = useMachine(tagsInput.machine, { validate(details) { // Example: only allow lowercase alphabetic tags return /^[a-z]+$/.test(details.inputValue) }, })

Blur behavior

When the tags input is blurred, you can configure the action the machine should take by passing the blurBehavior option to the context.

  • "add" — Adds the tag to the list of tags.
  • "clear" — Clears the tags input value.
const service = useMachine(tagsInput.machine, { blurBehavior: "add", })

Paste behavior

To add a tag when a arbitrary value is pasted in the input element, pass the addOnPaste option.

When a value is pasted, the machine will:

  • check if the value is a valid tag based on the validate option
  • split the value by the delimiter option passed
const service = useMachine(tagsInput.machine, { addOnPaste: true, })

Disable tag editing

by default the tags can be edited by double clicking on the tag or focusing on them and pressing Enter. To disable this behavior, pass the allowEditTag: false

const service = useMachine(tagsInput.machine, { allowEditTag: false, })

Listening for events

During the lifetime of the tags input interaction, here's a list of events we emit:

  • onValueChange — invoked when the tag value changes.
  • onHighlightChange — invoked when a tag has visual focus.
  • onValueInvalid — invoked when the max tag count is reached or the validate function returns false.
const service = useMachine(tagsInput.machine, { onValueChange(details) { // details => { value: string[] } console.log("tags changed to:", details.value) }, onHighlightChange(details) { // details => { value: string } console.log("highlighted tag:", details.value) }, onValueInvalid(details) { console.log("Invalid!", details.reason) }, })

Styling guide

Earlier, we mentioned that each accordion part has a data-part attribute added to them to select and style them in the DOM.

Focused state

The combobox input is focused when the user clicks on the input element. In this focused state, the root, label, input.

[data-part="root"][data-focus] { /* styles for root focus state */ } [data-part="label"][data-focus] { /* styles for label focus state */ } [data-part="input"]:focus { /* styles for input focus state */ }

Invalid state

When the tags input is invalid by setting the invalid: true in the machine's context, the data-invalid attribute is set on the root, input, control, and label.

[data-part="root"][data-invalid] { /* styles for invalid state for root */ } [data-part="label"][data-invalid] { /* styles for invalid state for label */ } [data-part="input"][data-invalid] { /* styles for invalid state for input */ }

Disabled state

When the tags input is disabled by setting the disabled: true in the machine's context, the data-disabled attribute is set on the root, input, control and label.

[data-part="root"][data-disabled] { /* styles for disabled state for root */ } [data-part="label"][data-disabled] { /* styles for disabled state for label */ } [data-part="input"][data-disabled] { /* styles for disabled state for input */ } [data-part="control"][data-disabled] { /* styles for disabled state for control */ }

When a tag is disabled, the data-disabled attribute is set on the tag.

[data-part="item-preview"][data-disabled] { /* styles for disabled tag */ }

Highlighted state

When a tag is highlighted via the keyboard navigation or pointer hover, a data-highlighted attribute is set on the tag.

[data-part="item-preview"][data-highlighted] { /* styles for visual focus */ }

Readonly state

When the tags input is in its readonly state, the data-readonly attribute is set on the root, label, input and control.

[data-part="root"][data-readonly] { /* styles for readonly for root */ } [data-part="control"][data-readonly] { /* styles for readonly for control */ } [data-part="input"][data-readonly] { /* styles for readonly for input */ } [data-part="label"][data-readonly] { /* styles for readonly for label */ }

Methods and Properties

Machine Context

The tags input machine exposes the following context properties:

  • idsPartial<{ root: string; input: string; hiddenInput: string; clearBtn: string; label: string; control: string; item: (opts: ItemProps) => string; itemDeleteTrigger: (opts: ItemProps) => string; itemInput: (opts: ItemProps) => string; }>The ids of the elements in the tags input. Useful for composition.
  • translationsIntlTranslationsSpecifies the localized strings that identifies the accessibility elements and their states
  • maxLengthnumberThe max length of the input.
  • delimiterstring | RegExpThe character that serves has: - event key to trigger the addition of a new tag - character used to split tags when pasting into the input
  • autoFocusbooleanWhether the input should be auto-focused
  • disabledbooleanWhether the tags input should be disabled
  • readOnlybooleanWhether the tags input should be read-only
  • invalidbooleanWhether the tags input is invalid
  • requiredbooleanWhether the tags input is required
  • editablebooleanWhether a tag can be edited after creation, by pressing `Enter` or double clicking.
  • inputValuestringThe controlled tag input's value
  • defaultInputValuestringThe initial tag input value when rendered. Use when you don't need to control the tag input value.
  • valuestring[]The controlled tag value
  • defaultValuestring[]The initial tag value when rendered. Use when you don't need to control the tag value.
  • onValueChange(details: ValueChangeDetails) => voidCallback fired when the tag values is updated
  • onInputValueChange(details: InputValueChangeDetails) => voidCallback fired when the input value is updated
  • onHighlightChange(details: HighlightChangeDetails) => voidCallback fired when a tag is highlighted by pointer or keyboard navigation
  • onValueInvalid(details: ValidityChangeDetails) => voidCallback fired when the max tag count is reached or the `validateTag` function returns `false`
  • validate(details: ValidateArgs) => booleanReturns a boolean that determines whether a tag can be added. Useful for preventing duplicates or invalid tag values.
  • blurBehavior"clear" | "add"The behavior of the tags input when the input is blurred - `"add"`: add the input value as a new tag - `"clear"`: clear the input value
  • addOnPastebooleanWhether to add a tag when you paste values into the tag input
  • maxnumberThe max number of tags
  • allowOverflowbooleanWhether to allow tags to exceed max. In this case, we'll attach `data-invalid` to the root
  • namestringThe name attribute for the input. Useful for form submissions
  • formstringThe associate form of the underlying input element.
  • dir"ltr" | "rtl"The document's text/writing direction.
  • idstringThe unique identifier of the machine.
  • getRootNode() => ShadowRoot | Node | DocumentA root node to correctly resolve document in custom environments. E.x.: Iframes, Electron.
  • onPointerDownOutside(event: PointerDownOutsideEvent) => voidFunction called when the pointer is pressed down outside the component
  • onFocusOutside(event: FocusOutsideEvent) => voidFunction called when the focus is moved outside the component
  • onInteractOutside(event: InteractOutsideEvent) => voidFunction called when an interaction happens outside the component

Machine API

The tags input api exposes the following methods:

  • emptybooleanWhether the tags are empty
  • inputValuestringThe value of the tags entry input.
  • valuestring[]The value of the tags as an array of strings.
  • valueAsStringstringThe value of the tags as a string.
  • countnumberThe number of the tags.
  • atMaxbooleanWhether the tags have reached the max limit.
  • setValue(value: string[]) => voidFunction to set the value of the tags.
  • clearValue(id?: string) => voidFunction to clear the value of the tags.
  • addValue(value: string) => voidFunction to add a tag to the tags.
  • setValueAtIndex(index: number, value: string) => voidFunction to set the value of a tag at the given index.
  • setInputValue(value: string) => voidFunction to set the value of the tags entry input.
  • clearInputValueVoidFunctionFunction to clear the value of the tags entry input.
  • focusVoidFunctionFunction to focus the tags entry input.
  • getItemState(props: ItemProps) => ItemStateReturns the state of a tag

Data Attributes

Root
data-scope
tags-input
data-part
root
data-invalid
Present when invalid
data-readonly
Present when read-only
data-disabled
Present when disabled
data-focus
Present when focused
data-empty
Present when the content is empty
Label
data-scope
tags-input
data-part
label
data-disabled
Present when disabled
data-invalid
Present when invalid
data-readonly
Present when read-only
data-required
Present when required
Control
data-scope
tags-input
data-part
control
data-disabled
Present when disabled
data-readonly
Present when read-only
data-invalid
Present when invalid
data-focus
Present when focused
Input
data-scope
tags-input
data-part
input
data-invalid
Present when invalid
data-readonly
Present when read-only
data-empty
Present when the content is empty
Item
data-scope
tags-input
data-part
item
data-value
The value of the item
data-disabled
Present when disabled
ItemPreview
data-scope
tags-input
data-part
item-preview
data-value
The value of the item
data-disabled
Present when disabled
data-highlighted
Present when highlighted
ItemText
data-scope
tags-input
data-part
item-text
data-disabled
Present when disabled
data-highlighted
Present when highlighted
ItemDeleteTrigger
data-scope
tags-input
data-part
item-delete-trigger
data-disabled
Present when disabled
data-highlighted
Present when highlighted
ClearTrigger
data-scope
tags-input
data-part
clear-trigger
data-readonly
Present when read-only

Accessibility

Keyboard Interactions

  • ArrowLeft
    Moves focus to the previous tag item
  • ArrowRight
    Moves focus to the next tag item
  • Backspace
    Deletes the tag item that has visual focus or the last tag item
  • Enter
    When a tag item has visual focus, it puts the tag in edit mode.
    When the input has focus, it adds the value to the list of tags
  • Delete
    Deletes the tag item that has visual focus
  • Control + V
    When `addOnPaste` is set. Adds the pasted value as a tags
Edit this page on GitHub

Skip to main content

Tag inputs render tags inside an input, followed by an actual text input. By default, tags are added when text is typed in the input field and the Enter or Comma key is pressed. Throughout the interaction, DOM focus remains on the input element.

Loading...

Features

  • Typing in the input and pressing enter will add new items
  • Clear button to reset all tags values
  • Add tags by pasting into the input
  • Delete tags on backspace
  • Edit tags after creation
  • Limit the number of tags
  • Navigate tags with keyboard
  • Custom validation to accept/reject tags

Installation

To use the tags input machine in your project, run the following command in your command line:

npm install @zag-js/tags-input @zag-js/svelte # or yarn add @zag-js/tags-input @zag-js/svelte

Anatomy

To set up the tags input correctly, you'll need to understand its anatomy and how we name its parts.

Each part includes a data-part attribute to help identify them in the DOM.

Usage

First, import the tags input package into your project

import * as tagsInput from "@zag-js/tags-input"

The tags input package exports two key functions:

  • machine — The state machine logic for the tags input widget.
  • connect — The function that translates the machine's state to JSX attributes and event handlers.

You'll also need to provide a unique id to the useMachine hook. This is used to ensure that every part has a unique identifier.

Next, import the required hooks and functions for your framework and use the tags input machine in your project 🔥

<script lang="ts"> import * as tagsInput from "@zag-js/tags-input" import { useMachine, normalizeProps } from "@zag-js/svelte" const id = $props.id() const service = useMachine(tagsInput.machine, { id, defaultValue: ["React", "Vue"], }) const api = $derived(tagsInput.connect(service, normalizeProps)) </script> <div {...api.getRootProps()}> {#each api.value as value, index} <span {...api.getItemProps({ index, value })}> <div {...api.getItemPreviewProps({ index, value })}> <span>{value} </span> <button {...api.getItemDeleteTriggerProps({ index, value })}> &#x2715; </button> </div> <input {...api.getItemInputProps({ index, value })} /> </span> {/each} <input placeholder="Add tag..." {...api.getInputProps()} /> </div>

When the input has an empty value or the caret is at the start position, the tags can be selected by using the arrow left and arrow right keys. When "visual" focus in on any tag:

  • Pressing Enter or double clicking on the tag will put the it in edit mode, allowing the user change its value and press Enter to commit the changes.
  • Pressing Delete or Backspace will delete the tag that has "visual" focus.

Setting the initial tags

To set the initial tag values, pass the defaultValue property in the machine's context.

const service = useMachine(tagsInput.machine, { defaultValue: ["React", "Redux", "TypeScript"], })

Controlled tags input

To control the tags input programmatically, pass the value and onValueChange properties to the machine function.

<script lang="ts"> let value = $state(["React", "Vue"]) const service = useMachine(tagsInput.machine, { get value() { return value }, onValueChange(details) { value = details.value }, }) </script>

Removing all tags

The tags input will remove all tags when the clear button is clicked. To remove all tags, use the provided clearButtonProps function from the api.

//... <div {...api.getControlProps()}> <input {...api.getInputProps()} /> <button {...api.getClearButtonProps()} /> </div> //...

To programmatically remove all tags, use the api.clearAll() method that's available in the connect.

Usage within forms

The tags input works when placed within a form and the form is submitted. We achieve this by:

  • ensuring we emit the input event as the value changes.
  • adding a name and value attribute to a hidden input so the tags can be accessed in the FormData.

To get this feature working you need to pass a name option to the context and render the hiddenInput element.

const service = useMachine(tagsInput.machine, { name: "tags", defaultValue: ["React", "Redux", "TypeScript"], })

Limiting the number of tags

To limit the number of tags within the component, you can set the max property to the limit you want. The default value is Infinity.

When the tag reaches the limit, new tags cannot be added except the allowOverflow option is passed to the context.

const service = useMachine(tagsInput.machine, { max: 10, allowOverflow: true, })

Validating Tags

Before a tag is added, the machine provides a validate function you can use to determine whether to accept or reject a tag.

Note: Duplicate tags are automatically prevented by design. You don't need to handle this in your validate function.

Common use-cases for validating tags include enforcing format, length, or content rules.

const service = useMachine(tagsInput.machine, { validate(details) { // Example: only allow lowercase alphabetic tags return /^[a-z]+$/.test(details.inputValue) }, })

Blur behavior

When the tags input is blurred, you can configure the action the machine should take by passing the blurBehavior option to the context.

  • "add" — Adds the tag to the list of tags.
  • "clear" — Clears the tags input value.
const service = useMachine(tagsInput.machine, { blurBehavior: "add", })

Paste behavior

To add a tag when a arbitrary value is pasted in the input element, pass the addOnPaste option.

When a value is pasted, the machine will:

  • check if the value is a valid tag based on the validate option
  • split the value by the delimiter option passed
const service = useMachine(tagsInput.machine, { addOnPaste: true, })

Disable tag editing

by default the tags can be edited by double clicking on the tag or focusing on them and pressing Enter. To disable this behavior, pass the allowEditTag: false

const service = useMachine(tagsInput.machine, { allowEditTag: false, })

Listening for events

During the lifetime of the tags input interaction, here's a list of events we emit:

  • onValueChange — invoked when the tag value changes.
  • onHighlightChange — invoked when a tag has visual focus.
  • onValueInvalid — invoked when the max tag count is reached or the validate function returns false.
const service = useMachine(tagsInput.machine, { onValueChange(details) { // details => { value: string[] } console.log("tags changed to:", details.value) }, onHighlightChange(details) { // details => { value: string } console.log("highlighted tag:", details.value) }, onValueInvalid(details) { console.log("Invalid!", details.reason) }, })

Styling guide

Earlier, we mentioned that each accordion part has a data-part attribute added to them to select and style them in the DOM.

Focused state

The combobox input is focused when the user clicks on the input element. In this focused state, the root, label, input.

[data-part="root"][data-focus] { /* styles for root focus state */ } [data-part="label"][data-focus] { /* styles for label focus state */ } [data-part="input"]:focus { /* styles for input focus state */ }

Invalid state

When the tags input is invalid by setting the invalid: true in the machine's context, the data-invalid attribute is set on the root, input, control, and label.

[data-part="root"][data-invalid] { /* styles for invalid state for root */ } [data-part="label"][data-invalid] { /* styles for invalid state for label */ } [data-part="input"][data-invalid] { /* styles for invalid state for input */ }

Disabled state

When the tags input is disabled by setting the disabled: true in the machine's context, the data-disabled attribute is set on the root, input, control and label.

[data-part="root"][data-disabled] { /* styles for disabled state for root */ } [data-part="label"][data-disabled] { /* styles for disabled state for label */ } [data-part="input"][data-disabled] { /* styles for disabled state for input */ } [data-part="control"][data-disabled] { /* styles for disabled state for control */ }

When a tag is disabled, the data-disabled attribute is set on the tag.

[data-part="item-preview"][data-disabled] { /* styles for disabled tag */ }

Highlighted state

When a tag is highlighted via the keyboard navigation or pointer hover, a data-highlighted attribute is set on the tag.

[data-part="item-preview"][data-highlighted] { /* styles for visual focus */ }

Readonly state

When the tags input is in its readonly state, the data-readonly attribute is set on the root, label, input and control.

[data-part="root"][data-readonly] { /* styles for readonly for root */ } [data-part="control"][data-readonly] { /* styles for readonly for control */ } [data-part="input"][data-readonly] { /* styles for readonly for input */ } [data-part="label"][data-readonly] { /* styles for readonly for label */ }

Methods and Properties

Machine Context

The tags input machine exposes the following context properties:

  • idsPartial<{ root: string; input: string; hiddenInput: string; clearBtn: string; label: string; control: string; item: (opts: ItemProps) => string; itemDeleteTrigger: (opts: ItemProps) => string; itemInput: (opts: ItemProps) => string; }>The ids of the elements in the tags input. Useful for composition.
  • translationsIntlTranslationsSpecifies the localized strings that identifies the accessibility elements and their states
  • maxLengthnumberThe max length of the input.
  • delimiterstring | RegExpThe character that serves has: - event key to trigger the addition of a new tag - character used to split tags when pasting into the input
  • autoFocusbooleanWhether the input should be auto-focused
  • disabledbooleanWhether the tags input should be disabled
  • readOnlybooleanWhether the tags input should be read-only
  • invalidbooleanWhether the tags input is invalid
  • requiredbooleanWhether the tags input is required
  • editablebooleanWhether a tag can be edited after creation, by pressing `Enter` or double clicking.
  • inputValuestringThe controlled tag input's value
  • defaultInputValuestringThe initial tag input value when rendered. Use when you don't need to control the tag input value.
  • valuestring[]The controlled tag value
  • defaultValuestring[]The initial tag value when rendered. Use when you don't need to control the tag value.
  • onValueChange(details: ValueChangeDetails) => voidCallback fired when the tag values is updated
  • onInputValueChange(details: InputValueChangeDetails) => voidCallback fired when the input value is updated
  • onHighlightChange(details: HighlightChangeDetails) => voidCallback fired when a tag is highlighted by pointer or keyboard navigation
  • onValueInvalid(details: ValidityChangeDetails) => voidCallback fired when the max tag count is reached or the `validateTag` function returns `false`
  • validate(details: ValidateArgs) => booleanReturns a boolean that determines whether a tag can be added. Useful for preventing duplicates or invalid tag values.
  • blurBehavior"clear" | "add"The behavior of the tags input when the input is blurred - `"add"`: add the input value as a new tag - `"clear"`: clear the input value
  • addOnPastebooleanWhether to add a tag when you paste values into the tag input
  • maxnumberThe max number of tags
  • allowOverflowbooleanWhether to allow tags to exceed max. In this case, we'll attach `data-invalid` to the root
  • namestringThe name attribute for the input. Useful for form submissions
  • formstringThe associate form of the underlying input element.
  • dir"ltr" | "rtl"The document's text/writing direction.
  • idstringThe unique identifier of the machine.
  • getRootNode() => ShadowRoot | Node | DocumentA root node to correctly resolve document in custom environments. E.x.: Iframes, Electron.
  • onPointerDownOutside(event: PointerDownOutsideEvent) => voidFunction called when the pointer is pressed down outside the component
  • onFocusOutside(event: FocusOutsideEvent) => voidFunction called when the focus is moved outside the component
  • onInteractOutside(event: InteractOutsideEvent) => voidFunction called when an interaction happens outside the component

Machine API

The tags input api exposes the following methods:

  • emptybooleanWhether the tags are empty
  • inputValuestringThe value of the tags entry input.
  • valuestring[]The value of the tags as an array of strings.
  • valueAsStringstringThe value of the tags as a string.
  • countnumberThe number of the tags.
  • atMaxbooleanWhether the tags have reached the max limit.
  • setValue(value: string[]) => voidFunction to set the value of the tags.
  • clearValue(id?: string) => voidFunction to clear the value of the tags.
  • addValue(value: string) => voidFunction to add a tag to the tags.
  • setValueAtIndex(index: number, value: string) => voidFunction to set the value of a tag at the given index.
  • setInputValue(value: string) => voidFunction to set the value of the tags entry input.
  • clearInputValueVoidFunctionFunction to clear the value of the tags entry input.
  • focusVoidFunctionFunction to focus the tags entry input.
  • getItemState(props: ItemProps) => ItemStateReturns the state of a tag

Data Attributes

Root
data-scope
tags-input
data-part
root
data-invalid
Present when invalid
data-readonly
Present when read-only
data-disabled
Present when disabled
data-focus
Present when focused
data-empty
Present when the content is empty
Label
data-scope
tags-input
data-part
label
data-disabled
Present when disabled
data-invalid
Present when invalid
data-readonly
Present when read-only
data-required
Present when required
Control
data-scope
tags-input
data-part
control
data-disabled
Present when disabled
data-readonly
Present when read-only
data-invalid
Present when invalid
data-focus
Present when focused
Input
data-scope
tags-input
data-part
input
data-invalid
Present when invalid
data-readonly
Present when read-only
data-empty
Present when the content is empty
Item
data-scope
tags-input
data-part
item
data-value
The value of the item
data-disabled
Present when disabled
ItemPreview
data-scope
tags-input
data-part
item-preview
data-value
The value of the item
data-disabled
Present when disabled
data-highlighted
Present when highlighted
ItemText
data-scope
tags-input
data-part
item-text
data-disabled
Present when disabled
data-highlighted
Present when highlighted
ItemDeleteTrigger
data-scope
tags-input
data-part
item-delete-trigger
data-disabled
Present when disabled
data-highlighted
Present when highlighted
ClearTrigger
data-scope
tags-input
data-part
clear-trigger
data-readonly
Present when read-only

Accessibility

Keyboard Interactions

  • ArrowLeft
    Moves focus to the previous tag item
  • ArrowRight
    Moves focus to the next tag item
  • Backspace
    Deletes the tag item that has visual focus or the last tag item
  • Enter
    When a tag item has visual focus, it puts the tag in edit mode.
    When the input has focus, it adds the value to the list of tags
  • Delete
    Deletes the tag item that has visual focus
  • Control + V
    When `addOnPaste` is set. Adds the pasted value as a tags
Edit this page on GitHub

Skip to main content

Tag inputs render tags inside an input, followed by an actual text input. By default, tags are added when text is typed in the input field and the Enter or Comma key is pressed. Throughout the interaction, DOM focus remains on the input element.

Loading...

Features

  • Typing in the input and pressing enter will add new items
  • Clear button to reset all tags values
  • Add tags by pasting into the input
  • Delete tags on backspace
  • Edit tags after creation
  • Limit the number of tags
  • Navigate tags with keyboard
  • Custom validation to accept/reject tags

Installation

To use the tags input machine in your project, run the following command in your command line:

npm install @zag-js/tags-input @zag-js/react # or yarn add @zag-js/tags-input @zag-js/react

Anatomy

To set up the tags input correctly, you'll need to understand its anatomy and how we name its parts.

Each part includes a data-part attribute to help identify them in the DOM.

Usage

First, import the tags input package into your project

import * as tagsInput from "@zag-js/tags-input"

The tags input package exports two key functions:

  • machine — The state machine logic for the tags input widget.
  • connect — The function that translates the machine's state to JSX attributes and event handlers.

You'll also need to provide a unique id to the useMachine hook. This is used to ensure that every part has a unique identifier.

Next, import the required hooks and functions for your framework and use the tags input machine in your project 🔥

import * as tagsInput from "@zag-js/tags-input" import { useMachine, normalizeProps } from "@zag-js/react" export function TagsInput() { const service = useMachine(tagsInput.machine, { id: "1", value: ["React", "Vue"], }) const api = tagsInput.connect(service, normalizeProps) return ( <div {...api.getRootProps()}> {api.value.map((value, index) => ( <span key={index} {...api.getItemProps({ index, value })}> <div {...api.getItemPreviewProps({ index, value })}> <span>{value} </span> <button {...api.getItemDeleteTriggerProps({ index, value })}> &#x2715; </button> </div> <input {...api.getItemInputProps({ index, value })} /> </span> ))} <input placeholder="Add tag..." {...api.getInputProps()} /> </div> ) }

When the input has an empty value or the caret is at the start position, the tags can be selected by using the arrow left and arrow right keys. When "visual" focus in on any tag:

  • Pressing Enter or double clicking on the tag will put the it in edit mode, allowing the user change its value and press Enter to commit the changes.
  • Pressing Delete or Backspace will delete the tag that has "visual" focus.

Setting the initial tags

To set the initial tag values, pass the defaultValue property in the machine's context.

const service = useMachine(tagsInput.machine, { defaultValue: ["React", "Redux", "TypeScript"], })

Controlled tags input

To control the tags input programmatically, pass the value and onValueChange properties to the machine function.

import { useState } from "react" export function ControlledTagsInput() { const [value, setValue] = useState(["React", "Vue"]) const service = useMachine(tagsInput.machine, { value, onValueChange(details) { setValue(details.value) }, }) return ( // ... ) }

Removing all tags

The tags input will remove all tags when the clear button is clicked. To remove all tags, use the provided clearButtonProps function from the api.

//... <div {...api.getControlProps()}> <input {...api.getInputProps()} /> <button {...api.getClearButtonProps()} /> </div> //...

To programmatically remove all tags, use the api.clearAll() method that's available in the connect.

Usage within forms

The tags input works when placed within a form and the form is submitted. We achieve this by:

  • ensuring we emit the input event as the value changes.
  • adding a name and value attribute to a hidden input so the tags can be accessed in the FormData.

To get this feature working you need to pass a name option to the context and render the hiddenInput element.

const service = useMachine(tagsInput.machine, { name: "tags", defaultValue: ["React", "Redux", "TypeScript"], })

Limiting the number of tags

To limit the number of tags within the component, you can set the max property to the limit you want. The default value is Infinity.

When the tag reaches the limit, new tags cannot be added except the allowOverflow option is passed to the context.

const service = useMachine(tagsInput.machine, { max: 10, allowOverflow: true, })

Validating Tags

Before a tag is added, the machine provides a validate function you can use to determine whether to accept or reject a tag.

Note: Duplicate tags are automatically prevented by design. You don't need to handle this in your validate function.

Common use-cases for validating tags include enforcing format, length, or content rules.

const service = useMachine(tagsInput.machine, { validate(details) { // Example: only allow lowercase alphabetic tags return /^[a-z]+$/.test(details.inputValue) }, })

Blur behavior

When the tags input is blurred, you can configure the action the machine should take by passing the blurBehavior option to the context.

  • "add" — Adds the tag to the list of tags.
  • "clear" — Clears the tags input value.
const service = useMachine(tagsInput.machine, { blurBehavior: "add", })

Paste behavior

To add a tag when a arbitrary value is pasted in the input element, pass the addOnPaste option.

When a value is pasted, the machine will:

  • check if the value is a valid tag based on the validate option
  • split the value by the delimiter option passed
const service = useMachine(tagsInput.machine, { addOnPaste: true, })

Disable tag editing

by default the tags can be edited by double clicking on the tag or focusing on them and pressing Enter. To disable this behavior, pass the allowEditTag: false

const service = useMachine(tagsInput.machine, { allowEditTag: false, })

Listening for events

During the lifetime of the tags input interaction, here's a list of events we emit:

  • onValueChange — invoked when the tag value changes.
  • onHighlightChange — invoked when a tag has visual focus.
  • onValueInvalid — invoked when the max tag count is reached or the validate function returns false.
const service = useMachine(tagsInput.machine, { onValueChange(details) { // details => { value: string[] } console.log("tags changed to:", details.value) }, onHighlightChange(details) { // details => { value: string } console.log("highlighted tag:", details.value) }, onValueInvalid(details) { console.log("Invalid!", details.reason) }, })

Styling guide

Earlier, we mentioned that each accordion part has a data-part attribute added to them to select and style them in the DOM.

Focused state

The combobox input is focused when the user clicks on the input element. In this focused state, the root, label, input.

[data-part="root"][data-focus] { /* styles for root focus state */ } [data-part="label"][data-focus] { /* styles for label focus state */ } [data-part="input"]:focus { /* styles for input focus state */ }

Invalid state

When the tags input is invalid by setting the invalid: true in the machine's context, the data-invalid attribute is set on the root, input, control, and label.

[data-part="root"][data-invalid] { /* styles for invalid state for root */ } [data-part="label"][data-invalid] { /* styles for invalid state for label */ } [data-part="input"][data-invalid] { /* styles for invalid state for input */ }

Disabled state

When the tags input is disabled by setting the disabled: true in the machine's context, the data-disabled attribute is set on the root, input, control and label.

[data-part="root"][data-disabled] { /* styles for disabled state for root */ } [data-part="label"][data-disabled] { /* styles for disabled state for label */ } [data-part="input"][data-disabled] { /* styles for disabled state for input */ } [data-part="control"][data-disabled] { /* styles for disabled state for control */ }

When a tag is disabled, the data-disabled attribute is set on the tag.

[data-part="item-preview"][data-disabled] { /* styles for disabled tag */ }

Highlighted state

When a tag is highlighted via the keyboard navigation or pointer hover, a data-highlighted attribute is set on the tag.

[data-part="item-preview"][data-highlighted] { /* styles for visual focus */ }

Readonly state

When the tags input is in its readonly state, the data-readonly attribute is set on the root, label, input and control.

[data-part="root"][data-readonly] { /* styles for readonly for root */ } [data-part="control"][data-readonly] { /* styles for readonly for control */ } [data-part="input"][data-readonly] { /* styles for readonly for input */ } [data-part="label"][data-readonly] { /* styles for readonly for label */ }

Methods and Properties

Machine Context

The tags input machine exposes the following context properties:

  • idsPartial<{ root: string; input: string; hiddenInput: string; clearBtn: string; label: string; control: string; item: (opts: ItemProps) => string; itemDeleteTrigger: (opts: ItemProps) => string; itemInput: (opts: ItemProps) => string; }>The ids of the elements in the tags input. Useful for composition.
  • translationsIntlTranslationsSpecifies the localized strings that identifies the accessibility elements and their states
  • maxLengthnumberThe max length of the input.
  • delimiterstring | RegExpThe character that serves has: - event key to trigger the addition of a new tag - character used to split tags when pasting into the input
  • autoFocusbooleanWhether the input should be auto-focused
  • disabledbooleanWhether the tags input should be disabled
  • readOnlybooleanWhether the tags input should be read-only
  • invalidbooleanWhether the tags input is invalid
  • requiredbooleanWhether the tags input is required
  • editablebooleanWhether a tag can be edited after creation, by pressing `Enter` or double clicking.
  • inputValuestringThe controlled tag input's value
  • defaultInputValuestringThe initial tag input value when rendered. Use when you don't need to control the tag input value.
  • valuestring[]The controlled tag value
  • defaultValuestring[]The initial tag value when rendered. Use when you don't need to control the tag value.
  • onValueChange(details: ValueChangeDetails) => voidCallback fired when the tag values is updated
  • onInputValueChange(details: InputValueChangeDetails) => voidCallback fired when the input value is updated
  • onHighlightChange(details: HighlightChangeDetails) => voidCallback fired when a tag is highlighted by pointer or keyboard navigation
  • onValueInvalid(details: ValidityChangeDetails) => voidCallback fired when the max tag count is reached or the `validateTag` function returns `false`
  • validate(details: ValidateArgs) => booleanReturns a boolean that determines whether a tag can be added. Useful for preventing duplicates or invalid tag values.
  • blurBehavior"clear" | "add"The behavior of the tags input when the input is blurred - `"add"`: add the input value as a new tag - `"clear"`: clear the input value
  • addOnPastebooleanWhether to add a tag when you paste values into the tag input
  • maxnumberThe max number of tags
  • allowOverflowbooleanWhether to allow tags to exceed max. In this case, we'll attach `data-invalid` to the root
  • namestringThe name attribute for the input. Useful for form submissions
  • formstringThe associate form of the underlying input element.
  • dir"ltr" | "rtl"The document's text/writing direction.
  • idstringThe unique identifier of the machine.
  • getRootNode() => ShadowRoot | Node | DocumentA root node to correctly resolve document in custom environments. E.x.: Iframes, Electron.
  • onPointerDownOutside(event: PointerDownOutsideEvent) => voidFunction called when the pointer is pressed down outside the component
  • onFocusOutside(event: FocusOutsideEvent) => voidFunction called when the focus is moved outside the component
  • onInteractOutside(event: InteractOutsideEvent) => voidFunction called when an interaction happens outside the component

Machine API

The tags input api exposes the following methods:

  • emptybooleanWhether the tags are empty
  • inputValuestringThe value of the tags entry input.
  • valuestring[]The value of the tags as an array of strings.
  • valueAsStringstringThe value of the tags as a string.
  • countnumberThe number of the tags.
  • atMaxbooleanWhether the tags have reached the max limit.
  • setValue(value: string[]) => voidFunction to set the value of the tags.
  • clearValue(id?: string) => voidFunction to clear the value of the tags.
  • addValue(value: string) => voidFunction to add a tag to the tags.
  • setValueAtIndex(index: number, value: string) => voidFunction to set the value of a tag at the given index.
  • setInputValue(value: string) => voidFunction to set the value of the tags entry input.
  • clearInputValueVoidFunctionFunction to clear the value of the tags entry input.
  • focusVoidFunctionFunction to focus the tags entry input.
  • getItemState(props: ItemProps) => ItemStateReturns the state of a tag

Data Attributes

Root
data-scope
tags-input
data-part
root
data-invalid
Present when invalid
data-readonly
Present when read-only
data-disabled
Present when disabled
data-focus
Present when focused
data-empty
Present when the content is empty
Label
data-scope
tags-input
data-part
label
data-disabled
Present when disabled
data-invalid
Present when invalid
data-readonly
Present when read-only
data-required
Present when required
Control
data-scope
tags-input
data-part
control
data-disabled
Present when disabled
data-readonly
Present when read-only
data-invalid
Present when invalid
data-focus
Present when focused
Input
data-scope
tags-input
data-part
input
data-invalid
Present when invalid
data-readonly
Present when read-only
data-empty
Present when the content is empty
Item
data-scope
tags-input
data-part
item
data-value
The value of the item
data-disabled
Present when disabled
ItemPreview
data-scope
tags-input
data-part
item-preview
data-value
The value of the item
data-disabled
Present when disabled
data-highlighted
Present when highlighted
ItemText
data-scope
tags-input
data-part
item-text
data-disabled
Present when disabled
data-highlighted
Present when highlighted
ItemDeleteTrigger
data-scope
tags-input
data-part
item-delete-trigger
data-disabled
Present when disabled
data-highlighted
Present when highlighted
ClearTrigger
data-scope
tags-input
data-part
clear-trigger
data-readonly
Present when read-only

Accessibility

Keyboard Interactions

  • ArrowLeft
    Moves focus to the previous tag item
  • ArrowRight
    Moves focus to the next tag item
  • Backspace
    Deletes the tag item that has visual focus or the last tag item
  • Enter
    When a tag item has visual focus, it puts the tag in edit mode.
    When the input has focus, it adds the value to the list of tags
  • Delete
    Deletes the tag item that has visual focus
  • Control + V
    When `addOnPaste` is set. Adds the pasted value as a tags
Edit this page on GitHub